' LngFnam2.bi
'******************************************************************************
DEFINT A-Z

%FALSE = 0
%TRUE = NOT %FALSE

' Access modes:
%OPEN_ACCESS_READONLY           =     0
%OPEN_ACCESS_WRITEONLY          =     1
%OPEN_ACCESS_READWRITE          =     2
%OPEN_ACCESS_RONOMODLASTACCESS  =     4

' Sharing modes:
%OPEN_SHARE_COMPATIBLE          =     0
%OPEN_SHARE_DENYREADWRITE       =  &h10
%OPEN_SHARE_DENYWRITE           =  &h20
%OPEN_SHARE_DENYREAD            =  &h30
%OPEN_SHARE_DENYNONE            =  &h40

' Flags:
%OPEN_FLAGS_NOINHERIT           =  &h80
%OPEN_FLAGS_NO_BUFFERING        = &h100
%OPEN_FLAGS_NO_COMPRESS         = &h200
%OPEN_FLAGS_ALIAS_HINT          = &h400
%OPEN_FLAGS_NOCRITERR           =&h2000
%OPEN_FLAGS_COMMIT              =&h4000

' Attributes:
%FILE_ATTRIBUTE_NORMAL          =     0
%FILE_ATTRIBUTE_READONLY        =     1
%FILE_ATTRIBUTE_HIDDEN          =     2
%FILE_ATTRIBUTE_SYSTEM          =     4
%FILE_ATTRIBUTE_VOLUME          =     8
%FILE_ATTRIBUTE_DIRECTORY       =  &h10
%FILE_ATTRIBUTE_ARCHIVE         =  &h20

%FILE_ATTRIBUTE_ALL             =  _
 %FILE_ATTRIBUTE_NORMAL + %FILE_ATTRIBUTE_READONLY + %FILE_ATTRIBUTE_HIDDEN + _
 %FILE_ATTRIBUTE_SYSTEM + %FILE_ATTRIBUTE_ARCHIVE
%FILE_ATTRIBUTE_READWRITE       =  _
 %FILE_ATTRIBUTE_NORMAL + %FILE_ATTRIBUTE_HIDDEN + %FILE_ATTRIBUTE_SYSTEM + _
 %FILE_ATTRIBUTE_ARCHIVE

' Maximum path length
%MAX_PATH       = 260
%MAX_DOS_PATH   =  67

' DOS errors

%NO_ERROR                       = 0
%ERROR_INVALID_FUNCTION         = 1
%ERROR_FILE_NOT_FOUND           = 2
%ERROR_PATH_NOT_FOUND           = 3
%ERROR_TOO_MANY_OPEN_FILES      = 4
%ERROR_ACCESS_DENIED            = 5
%ERROR_INVALID_HANDLE           = 6
%ERROR_ARENA_TRASHED            = 7
%ERROR_NOT_ENOUGH_MEMORY        = 8
%ERROR_INVALID_BLOCK            = 9
%ERROR_BAD_ENVIRONMENT          = &hA
%ERROR_BAD_FORMAT               = &hB
%ERROR_INVALID_ACCESS           = &hC
%ERROR_INVALID_DATA             = &hD
%ERROR_INVALID_DRIVE            = &hF
%ERROR_CURRENT_DIRECTORY        = &h10
%ERROR_NOT_SAME_DEVICE          = &h11
%ERROR_NO_MORE_FILES            = &h12
%ERROR_WRITE_PROTECT            = &h13
%ERROR_BAD_UNIT                 = &h14
%ERROR_NOT_READY                = &h15
%ERROR_BAD_COMMAND              = &h16
%ERROR_CRC                      = &h17
%ERROR_BAD_LENGTH               = &h18
%ERROR_SEEK                     = &h19
%ERROR_NOT_DOS_DISK             = &h1A
%ERROR_SECTOR_NOT_FOUND         = &h1B
%ERROR_OUT_OF_PAPER             = &h1C
%ERROR_WRITE_FAULT              = &h1D
%ERROR_READ_FAULT               = &h1E
%ERROR_GEN_FAILURE              = &h1F
%ERROR_SHARING_VIOLATION        = &h20
%ERROR_LOCK_VIOLATION           = &h21
%ERROR_WRONG_DISK               = &h22
%ERROR_FCB_UNAVAILABLE          = &h23
%ERROR_SHARING_BUFFER_EXCEEDED  = &h24
%ERROR_CODE_PAGE_MISMATCHED     = &h25
%ERROR_HANDLE_EOF               = &h26
%ERROR_HANDLE_DISK_FULL         = &h27
%ERROR_NOT_SUPPORTED            = &h32
%ERROR_REM_NOT_LIST             = &h33
%ERROR_DUP_NAME                 = &h34
%ERROR_BAD_NETPATH              = &h35
%ERROR_NETWORK_BUSY             = &h36
%ERROR_DEV_NOT_EXIST            = &h37
%ERROR_TOO_MANY_CMDS            = &h38
%ERROR_ADAP_HDW_ERR             = &h39
%ERROR_BAD_NET_RESP             = &h3A
%ERROR_UNEXP_NET_ERR            = &h3B
%ERROR_BAD_REM_ADAP             = &h3C
%ERROR_PRINTQ_FULL              = &h3D
%ERROR_NO_SPOOL_SPACE           = &h3E
%ERROR_PRINT_CANCELLED          = &h3F
%ERROR_NETNAME_DELETED          = &h40
%ERROR_NETWORK_ACCESS_DENIED    = &h41
%ERROR_BAD_DEV_TYPE             = &h42
%ERROR_BAD_NET_NAME             = &h43
%ERROR_TOO_MANY_NAMES           = &h44
%ERROR_TOO_MANY_SESS            = &h45
%ERROR_SHARING_PAUSED           = &h46
%ERROR_REQ_NOT_ACCEP            = &h47
%ERROR_REDIR_PAUSED             = &h48
%ERROR_FILE_EXISTS              = &h50
%ERROR_DUP_FCB                  = &h51
%ERROR_CANNOT_MAKE              = &h52
%ERROR_FAIL_I24                 = &h53
%ERROR_OUT_OF_STRUCTURES        = &h54
%ERROR_ALREADY_ASSIGNED         = &h55
%ERROR_INVALID_PASSWORD         = &h56
%ERROR_INVALID_PARAMETER        = &h57
%ERROR_NET_WRITE_FAULT          = &h58
%ERROR_SYS_COMP_NOT_LOADED      = &h5A

' Win32 structure for file info

TYPE Win32_Find_Data
  dwFileAttributes      AS DWORD
  ftCreationTime        AS QUAD
  ftLastAccessTime      AS QUAD
  ftLastWriteTime       AS QUAD
  nFileSizeHigh         AS DWORD
  nFileSizeLow          AS DWORD
  dwReserved0           AS DWORD
  dwReserved1           AS DWORD
  cFileName             AS STRING * %MAX_PATH
  cAlternateFileName    AS STRING * 14
END TYPE

' DOS structure for file info

TYPE FileInfo
  fiReserved            AS STRING * 21  'for DOS' internal use
  fiAttribute           AS BYTE         'file attribute code
  fiFileTime            AS WORD         'file time (in DOS format)
  fiFileDate            AS WORD         'file date (in DOS format)
  fiSize                AS DWORD        'file size (in bytes)
  fiFileName            AS STRING * 13  'file name (without path)
END TYPE

DECLARE FUNCTION LfnAlias (BYVAL Lfn AS STRING) AS STRING
DECLARE FUNCTION LfnChDir (BYVAL Directory AS STRING) AS INTEGER
DECLARE FUNCTION LfnCurDir (BYVAL Drive AS STRING) AS STRING
DECLARE FUNCTION LfnDirFirst (BYVAL Mask AS STRING, BYVAL Attr AS BYTE) _
        AS STRING
DECLARE FUNCTION LfnDirNext () AS STRING
DECLARE FUNCTION LfnDirAlias () AS STRING
DECLARE SUB      LfnFiles ()
DECLARE FUNCTION LfnGetAttrib (BYVAL File AS STRING) AS INTEGER
DECLARE FUNCTION LfnKill (BYVAL File AS STRING) AS INTEGER
DECLARE FUNCTION LfnMkDir (BYVAL Directory AS STRING) AS INTEGER
DECLARE FUNCTION LfnName (BYVAL OldName AS STRING, BYVAL NewName AS STRING) _
                 AS INTEGER
DECLARE FUNCTION LfnRmDir (BYVAL Directory AS STRING) AS INTEGER
DECLARE FUNCTION LfnSetAttrib (BYVAL File AS STRING, BYVAL Attribs AS WORD) _
                 AS INTEGER
DECLARE FUNCTION LfnSupported () AS INTEGER
DECLARE FUNCTION CurDrive () AS STRING
DECLARE FUNCTION DiskFree (BYVAL Drive AS STRING) AS DWORD
DECLARE FUNCTION DOSErr () AS INTEGER
DECLARE FUNCTION DOSErrTest () AS INTEGER
DECLARE FUNCTION GetDTA () AS DWORD
DECLARE FUNCTION GetPtrFindData () AS DWORD
DECLARE SUB      SetDOSErr (BYVAL DOSErr AS INTEGER)

